=== debian/changelog ===
cgal (5.3-3build1) jammy; urgency=medium

  * No-change rebuild against libipe7.2.24

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Nov 2021 07:48:26 +0000

cgal (5.3-3) unstable; urgency=medium

  * Do not put CGAL Qt5 headers into libcgal-dev on architectures where Qt5
    support is disabled (Closes: #993329).
  * Fix timestamp for demos/examples by passing absolute filename to
    --mtime option of tar.

 -- Joachim Reichel <reichel@debian.org>  Tue, 31 Aug 2021 22:27:58 +0200

cgal (5.3-2) unstable; urgency=medium

  * Upload to unstable.
  * Use timestamp of debian/changelog for demos/exampels to improve
    reproducibility in case of patches.

 -- Joachim Reichel <reichel@debian.org>  Sun, 15 Aug 2021 17:00:18 +0200

cgal (5.3-1) experimental; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Wed, 07 Jul 2021 21:15:39 +0200

cgal (5.2.2-1) experimental; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Wed, 02 Jun 2021 21:34:15 +0200

cgal (5.2.1-1) experimental; urgency=medium

  * New upstream release.
  * Remove patches for Boost warnings and out-of-bounds acceses
    (superseded upstream).

 -- Joachim Reichel <reichel@debian.org>  Mon, 22 Mar 2021 19:12:53 +0100
